# Team BIT-China 2022 Software Tool

If you team competes in the [**Software & AI** track](https://competition.igem.org/participation/tracks) or wants to
apply for the [**Best Software Tool** Award](https://competition.igem.org/judging/awards), you **MUST** host all the
code of your team's software tool in this repository, `main` branch. By the **Wiki Freeze**, a
[release](https://docs.gitlab.com/ee/user/project/releases/) will be automatically created as the judging artifact of
this software tool. You will be able to keep working on your software after the Grand Jamboree.

> If your team does not have any software tool, you can totally ignore this repository. If left unchanged, this
repository will be automatically deleted by the end of the season.



## Description
Our team has developed a software that can perform univariate output BP neural network prediction. This software we developed using the Guide function that comes with Matlab. The user only needs to import the training set, the test set, the dataset to be predicted and then simply adjust the parameters related to the neural network on the software, such as the number of nodes, the learning rate, the error requirement, the neural network training algorithm and so on. After the user has trained the neural network, our software plots the fit curve and performs a goodness-of-fit and error calculation. The user can also export the trained network as a .mat file for subsequent use of the neural network on Matlab. During the development of the software, we found that the Guide function will be gradually replaced in versions of Matlab after R2021. For this reason, and in order to increase the universality of our software, we have redeveloped the software using the App Designer function that comes with the newer version of Matlab. There are no major differences between the two versions in terms of how to use the software.

## Installation
Please note that this software is based on Matlab's own Guide function and App Designer function, so this software can only be run in Matlab's compiled environment. After downloading this software, users can simply drag it into the current folder area of Matlab, right-click on the installation package, select Install and install it to the My Apps section. The user can then use the software later by simply clicking on the installed software in My App and it will work.
Requirements：
Software using the Guide version requires that the user's Matlab version is prior to version R2021b.
Software using the App Designer version requires the user's Matlab version to be after version R2016.
The Matlab version used by the developer is R2021b and users can change their Matlab version to R2021b if they are experiencing version incompatibility problems.
If there is a problem with the installation process, then most likely it is due to a version incompatibility issue. You can switch to another version of the software to use.

## Usage
https://2022.igem.wiki/bit-china/software

## Contributing
Software developers accept modifications and contributions to our software from others. Because a software developer is in fact a beginner, during the development of these software, the developer is also gradually learning how to develop the software. Due to the limited knowledge of the developers, there are bound to be many problems during the development process. We also hope that future users will be able to further modify and improve our software in the process of using it.
In the spirit of open source, we have uploaded the files that can be edited in Matlab's Guide interface and App Designer interface. Users at a later stage can further modify and add new functions to the software developed by the developers.

## Authors and acknowledgment
The software was developed by Yang Lee. Thanks to my teammates, we have completed this year's project together.I would also like to thank my good friend Xiao Li、Yuao Chai、Hongyu Mu、Zihao Song、Chengrui Tao and other my friends for giving me a lot of help.Let's give a shout out to the handsome developer Yang Lee!
